; setup our Screen Width and Height here for easier tracking
#ScreenWidth  = 640
#ScreenHeight = 480

; Initialize the sprite and keyboard systems and a 640x480, 16-bit screen
If InitSprite() = 0 Or InitKeyboard() = 0 Or OpenScreen(#ScreenWidth,#ScreenHeight,16,"App Title") = 0
   MessageRequester("Error!", "Unable to Initialize Environment", #PB_MessageRequester_Ok)
   End
EndIf

ClearColor = RGB(0,0,0)

; Use the PNG decoder for image loads.
UsePNGImageDecoder()

; load in the sprites
Tile1_Image = LoadSprite(#PB_Any,"tile1.png")
Tile2_Image = LoadSprite(#PB_Any,"tile2.png")
Robot_Image = LoadSprite(#PB_Any,"robot.png")
; set the appropriate mask so we have transparencies
TransparentSpriteColor(Robot_Image,RGB(255,0,255))


Structure Sprites
 Image.l
 X.l
 Y.l
 Direction.l
 ZOrder.l
EndStructure

; setup a list for the Images
NewList Sprite.Sprites()

; Tile 1
AddElement(Sprite())
Sprite()\Image = Tile1_Image
Sprite()\X = 125
Sprite()\Y = 100
Sprite()\Direction = -1
Sprite()\ZOrder = -1

; Tile 2
AddElement(Sprite())
Sprite()\Image = Tile2_Image
Sprite()\X = 100
Sprite()\Y = 100
Sprite()\Direction = 0
Sprite()\ZOrder = 0

; Robot
AddElement(Sprite())
Sprite()\Image = Robot_Image
Sprite()\X = 75
Sprite()\Y = 100
Sprite()\Direction = 1
Sprite()\ZOrder = 1


Repeat
   ; clear the screen
   ClearScreen(ClearColor)
   
   ; Use this FOR...NEXT loop to cover each ZOrder plane of
   ; drawing.  So, if we're at -1, that will be the bottom. 
   ; 0 will be the middle (or baseline), and 1 will be the top.
   For Planes = -1 To 1
       ; run through each of our sprites   
       ForEach(Sprite())
          ; see if the current sprite is on this plane
          If Sprite()\ZOrder = Planes
             ; if so, move it based on its direction
             Select Sprite()\Direction
                Case -1
                   Sprite()\X = Sprite()\X - 1
                   If Sprite()\X < 75
                      Sprite()\Direction = 1
                   EndIf
                Case 1
                   Sprite()\X = Sprite()\X + 1
                   If Sprite()\X > 125
                      Sprite()\Direction = -1
                   EndIf
             EndSelect
             ; display the sprite
             DisplayTransparentSprite(Sprite()\Image,Sprite()\X,Sprite()\Y)
          EndIf
       Next
   Next

   ; put up text for exiting
   StartDrawing(ScreenOutput())
     DrawText(0,460,"Press Space to change the ZOrder, or ESC To quit")
   StopDrawing()

   FlipBuffers()

   ExamineKeyboard()

   ; if the spacebar gets pressed
   If KeyboardReleased(#PB_Key_Space)
      ; run through the sprites
      ForEach(Sprite())
         ; and alter their ZOrder and Direction
         Select Sprite()\ZOrder
            Case -1
                 Sprite()\ZOrder = 0
                 Sprite()\Direction = 0
            Case 0
                 Sprite()\ZOrder = 1
                 Sprite()\Direction = 1
            Case 1
                 Sprite()\ZOrder = -1
                 Sprite()\Direction = -1
         EndSelect
      Next
   EndIf
Until KeyboardReleased(#PB_Key_Escape)

End



; IDE Options = PureBasic 4.61 (Windows - x64)
; CursorPosition = 20