; Initialize the sprite and keyboard systems and a 640x480, 16-bit screen
If InitSprite() = 0 Or InitKeyboard() = 0 Or OpenScreen(640,480,16,"App Title") = 0
   MessageRequester("Error!", "Unable to Initialize Environment", #PB_MessageRequester_Ok)
   End
EndIf

ClearColor = RGB(0,0,0) 

; setup our structure
Structure Ships
           Name.s            ; Name of the ship
           WeaponsType.w     ; 0=basic, 1=advanced
           Shields.w         ; 200-400
           Armor.w           ; 200-400
EndStructure

; Define a pointer to the Structure
Define.Ships *Ship

; setup a new list for the Freighters
NewList Fighter.Ships()

;And now let's populate two Fighters by hand, using pointers
AddElement(Fighter())
If Fighter()
  Fighter()\Name = "Fast Fighter"
  Fighter()\WeaponsType = 1
  Fighter()\Shields= 300
  Fighter()\Armor = 200
EndIf

AddElement(Fighter())
If Fighter()
  Fighter()\Name = "Mid Fighter"
  Fighter()\WeaponsType = 0
  Fighter()\Shields= 400
  Fighter()\Armor = 400
EndIf

ClearScreen(ClearColor)          ; clear the screen to black
   
; Set up the vertical control variable
TextY = 0
   
StartDrawing(ScreenOutput())
     ; point to the first element in the Fighter List
     *Ship = FirstElement(Fighter())
     
     ; While it's a valid element
     While *Ship <> 0
           MissileText.s = "Name: " + *Ship\Name 
           DrawText(0,TextY,MissileText)
           TextY = TextY + 16

           MissileText.s = "Weapons Type: " + Str(*Ship\WeaponsType)
           DrawText(0,TextY,MissileText)
           TextY = TextY + 16            

           MissileText.s = "Shields: " + Str(*Ship\Shields)
           DrawText(0,TextY,MissileText)
           TextY = TextY + 16            

           MissileText.s = "Armor: " + Str(*Ship\Armor)
           DrawText(0,TextY,MissileText)
           TextY = TextY + 32            
           
           ; now point to the next element
           *Ship = NextElement(Fighter())

     Wend
        
     ; display a message so the user knows how exit     
     DrawText(0,400,"Press any key to Exit")

StopDrawing()

FlipBuffers()  ; show the output to the user

; wait for any key to be pressed
Repeat 
   ExamineKeyboard()
Until KeyboardReleased(#PB_Key_All)

End  ; end the program


; IDE Options = PureBasic 5.00 (Windows - x64)
; CursorPosition = 23
; FirstLine = 12