; Initialize the sprite and keyboard systems and a 640x480, 16-bit screen
If InitSprite() = 0 Or InitKeyboard() = 0 Or OpenScreen(640,480,16,"App Title") = 0
   MessageRequester("Error!", "Unable to Initialize Environment", #PB_MessageRequester_Ok)
   End
EndIf

 Declare.b AddNumbers(iNumber1.b, iNumber2.b)
 Declare.s ConcatString(String1.s, String2.s)
 Declare.f AvgNumbers(float1.f, float2.f, float3.f)
 Declare.w GetArray(Location.w)
 Declare SetupShips()
 Declare.w GetShip(ShipID.b)
 Declare WaitKey()
 
 ; make a dummy array and fill it with values
 Global Dim ArrayValues.l(4)
 ArrayValues(0) = 100
 ArrayValues(1) = 200
 ArrayValues(2) = 300
 ArrayValues(3) = 400
 ArrayValues(4) = 500

 ; define a type for Ships
 Structure Ships
     ShipID.b   ; what's it's ID?
     ShipName.s ; the name?
     Speed.b    ; top speed (3-7)
 EndStructure

 Global NewList Ship.Ships()
 
 ; add a few ships.  Note that this procedure does NOT
 ; return a value!
 SetupShips()

 ; call AddNumbers procedure and place the returned-value
 ; into the variable "byteValue"
 byteValue.b = AddNumbers(10,20)

 ; call ConcatString procedure and place the returned-value
 ; into the variable "stringValue"
 stringValue.s = ConcatString("How","dy")

 ; call AvgNumbers procedure and place the returned-value
 ; into the variable "floatValue"
 floatValue.f = AvgNumbers(1.495,3.772,11.1935)
 
 ; call GetArray procedure and place the returned-value
 ; into the variable "arrayValue"
 arrayValue.w = GetArray(3)

 ; call GetShip procedure and place the returned-value
 ; into the variable "ShipLocation"
 ShipLocation.w = GetShip(Random(9))
 ; now make sure we have that element selected
 SelectElement(Ship(),ShipLocation)

 ; Set up the vertical control variable
 TextY = 0

 StartDrawing(ScreenOutput()) 
 ; display returned values
 DrawText(0,TextY,"byteValue = " + Str(byteValue))
 TextY = TextY + 16
 
 DrawText(0,TextY,"stringValue = " + StringValue)
 TextY = TextY + 16
 
 DrawText(0,TextY,"floatValue = " + Str(floatValue.f))
 TextY = TextY + 16
 
 DrawText(0,TextY,"arrayValue = "+ Str(arrayValue))
 TextY = TextY + 32
 
 DrawText(0,TextY,"** Ship Info **")
 TextY = TextY + 16
 
 DrawText(0,TextY,"ID = " + Str(Ship()\ShipID))
 TextY = TextY + 16
 
 DrawText(0,TextY,"Name = " + Ship()\ShipName)
 TextY = TextY + 16
 
 DrawText(0,TextY,"Speed = " + Str(Ship()\Speed))
 StopDrawing()

 ; show the output to the users
 FlipBuffers()

 ; wait for a keypress
 WaitKey ()

 ; end the program
 End


 ;****************************************************
 ;             P R O C E D U R E S
 ;****************************************************
 ;     Author: John Logsdon
 ;   Last Upd: 8/22/2012
 
 ;****************************************************
 ;  Procedure: AddNumbers()
 ;    Purpose: add two numbers and return the result
 ;       Args: Two numbers
 ;    Returns: Byte - Sum of the two numbers sent 
 ;****************************************************
 Procedure.b AddNumbers(iNumber1.b, iNumber2.b)
     iSum.b = iNumber1 + iNumber2
     ProcedureReturn(iSum)
 EndProcedure

 ;****************************************************
 ;  Procedure: ConcatString$()
 ;    Purpose: concatonates two strings
 ;       Args: Two strings
 ;    Returns: the resultant string
 ;****************************************************
 Procedure.s ConcatString(String1.s, String2.s)
     ProcedureReturn(String1.s + String2.s)
 EndProcedure

 ;****************************************************
 ;   Procedure: AvgNumbers()
 ;    Purpose: Find the average of 3 floats
 ;       Args: Two floats
 ;    Returns: Sum of the two numbers sent
 ;****************************************************
 Procedure.f AvgNumbers(float1.f, float2.f, float3.f)
     avg.f = (float1 + float2 + float3) / 3
     ProcedureReturn(avg)
 EndProcedure

 ;****************************************************
 ;   Procedure: GetArray()
 ;    Purpose: Get a particular array value
 ;       Args: location in the array
 ;    Returns: The array value
 ;****************************************************
 Procedure.w GetArray(Location.w)
     ProcedureReturn(ArrayValues(Location))
 EndProcedure

 ;****************************************************
 ;   Procedure: SetupShips()
 ;    Purpose: adds a few ships to the Structure
 ;****************************************************
 Procedure SetupShips()
     For i = 0 To 9
         If AddElement(Ship()) <> 0
            Ship()\ShipID = i
            Ship()\ShipName = "Ship" + Str(i)
            Ship()\Speed = Random(4) + 3
         EndIf
     Next
 EndProcedure

 ;****************************************************
 ;  Procedure: GetShip()
 ;    Purpose: locates a ship and returns its index
 ;       Args: Ship's ID
 ;    Returns: the Index entry for the Ship
 ;****************************************************
 Procedure.w GetShip(ShipID.b)
     ForEach Ship()
         If Ship()\ShipID = ShipID.b
            Break 
         EndIf
     Next
     ProcedureReturn(ListIndex(Ship()))
 EndProcedure

 ;****************************************************
 ;  Procedure: WaitKey()
 ;    Purpose: Wait for a keypress
 ;****************************************************
 Procedure WaitKey()
    Repeat 
       ExamineKeyboard()
    Until KeyboardReleased(#PB_Key_All)
 EndProcedure

; IDE Options = PureBasic 4.61 (Windows - x64)
; CursorPosition = 100
; FirstLine = 84
; Folding = --